$(document).ready(function () {
    var tableAttachment = $('#tblAvailabilityAttachment').DataTable({
        responsive: false,
        "scrollX": true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "file" },
            { "data": "view" },
            { "data": "download" },
            { "data": "delete" },

        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },
        ],
    });


    $('#attachmnet_availability_token').val(AVAILABILITY_TOKEN);



    $('#btnAttachment').on('click', function () {

        $('#attachmentAvailabilityModal').modal('show');
    });


    $('input[name="suggestDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });

    $('#btnAvilabilityAction').on('click', function () {
        saveAvailability();
    });
});



Dropzone.options.availabilityDropzone = {
    dictDefaultMessage: 'Drop file here or click to upload!!!!!!!!',
    method: 'POST',
    url: '/sd/customerOrderList/uploadAvailabilityAttachment',
    params: {
        description: "abc"
    },
    addRemoveLinks: true,
    uploadMultiple: false,
    clickable: true,

    init: function () {
        var myDropzone = this;

        // Here's the change from enyo's tutorial...

        $("#submit-all").click(function (e) {
            e.preventDefault();
            e.stopPropagation();
            myDropzone.processQueue();
        }
        );

        this.on("sending", function (file, xhr, formData) {

            if (!checkStringLength($('#txtDescription').val(), 500)) {
                showWarningMessage('Data too long for "Description".')
                return;
            }

            // Will sendthe filesize along with the file as POST data.

            formData.append("foo", $('#txtDescription').val());

        });

        this.on("success", function (file, responseText) {
            var responseText = file.id // or however you would point to your assigned file ID here;
            console.log(responseText); // console should show the ID you pointed to
            // do stuff with file.id ...
            //alert();
        });

        this.on("addedfile", file => {
            console.log(file);
        });

        this.on("complete", function (file) {

            if (ACTION != 'view') {
                this.removeAllFiles(true);
                $('#txtDescription').val("");
                $('#attachmentAvailabilityModal').modal('hide');
            }
            allVesselAvilabilityAttachment(UPDATE_AVAILABILITY_ID);
            console.log(file);
        });

        this.on("errormultiple", function (files, response) {

        });
    }
};




function vessel_availability(id, status) {

    AVAILABILITY_TOKEN = Math.floor(Math.random() * 212345);
    $('#attachmnet_availability_token').val(AVAILABILITY_TOKEN);
    var table = $('#tblAvailabilityAttachment').DataTable();
    table.clear();
    table.rows.add([]).draw();
    getAvailabilityHeader(id);
}



function allVesselAvilabilityAttachment(id) {
    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/allAvailabilityAttachment/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                for (var i = 0; i < result.length; i++) {
                    var path = "'" + result[i].file_path + "'";
                    var id = "'" + result[i].vessel_availability_attachment_id + "'";
                    data.push({
                        "file": result[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewAvailabilityAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadAvailabilityAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteAvailabilityAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblAvailabilityAttachment').DataTable();
                //table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}





function viewAvailabilityAttachment(file) {
    window.open(file);

}


function downloadAvailabilityAttachment(file) {
    var link = document.createElement("a");
    link.download = file;
    link.href = file;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}


function deleteAvailabilityAttachment(id) {
    $.ajax({
        type: "DELETE",
        url: "/pp/customerOrder/deleteAttachment/" + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Attachment has been deleted successfully...");
                allAttachment(UPDATE_ORDER_ID);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });
}



function getAvailabilityHeader(id) {


    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/getAvailabilityHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetAvailabilityModal();
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;

                var table = $('#tblAvailabilityAttachment').DataTable();
                table.clear();
                $('#hidOrderId').val(id);
                $('#lblFactoryOrder').text(result.factory_po_num);
                $('#lblDestination').text(result.address);
                $('#lblCustomerPo').text(result.purchase_order);
                $('#lblETA').text(result.delivery_date);
                var currency = result.currency;
                $('#cmbCurrency').empty();
                for (var i = 0; i < currency.length; i++) {

                    $('#cmbCurrency').append('<option value="' + currency[i].currency_id + '">' + currency[i].currency + '</option>');
                }
                load_saved_availability(id);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
    $('#availabilityModal').modal('show');

}


function resetAvailabilityModal() {
    $('#formAvailability').trigger("reset");
}



function saveAvailability() {

    $.ajax({
        type: "POST",
        url: '/sd/customerOrderList/saveAvailability',
        data: {
            "token": AVAILABILITY_TOKEN,
            "factory_order_no": $('#lblFactoryOrder').text(),
            "eta": $('#lblETA').text(),
            "customer_po": $('#lblCustomerPo').text(),
            "designation": $('#lblDestination').text(),
            "cargo_ready_date": $('#lblCargoDate').text(),
            "suggest_vessel": $('#txtSuggestVessel').val(),
            "suggest_date": $('#txtSuggestDate').val(),
            "shipping_rate": $('#txtShippingRate').val(),
            "currency_id": $('#cmbCurrency').val(),
            "order_id": $('#hidOrderId').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success('Customer data has been saved successful...!');
                resetAvailabilityModal();
            } else {
                toastr.error('Something went wrong');
            }


        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {

        }

    });
}




function load_saved_availability(id) {

    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/load_saved_availability/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetAvailabilityModal();
        },
        success: function (response) {
            console.log(response);

            var result = response.data.result;

            if (result.current_availability) {
                $('#lblFactoryOrder').text(result.factory_po_num);
                $('#lblDestination').text(result.address);
                $('#lblCustomerPo').text(result.purchase_order);
                $('#lblETA').text(result.delivery_date);
                $('#txtSuggestVessel').val(result.suggest_vessel);
                $('#txtSuggestDate').val(result.suggest_date);
                $('#txtShippingRate').val(result.shipping_rate);
                setSelectedOption('cmbCurrency', result.currency_id);
                var data = [];
                for (var i = 0; i < result.attachment.length; i++) {
                    var path = "'" + result.attachment[i].file_path + "'";
                    var id = "'" + result.attachment[i].vessel_availability_attachment_id + "'";
                    AVAILABILITY_TOKEN = result.attachment[i].token;
                    $('#attachmnet_availability_token').val(AVAILABILITY_TOKEN);
                    data.push({
                        "file": result.attachment[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewAvailabilityAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadAvailabilityAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteAvailabilityAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblAvailabilityAttachment').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }


        },
        error: function (error) {
            console.log(error);

        },

    });
}

